"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.ContextMenu = ContextMenu;
var _lowcodeUtils = require("@redhare/lowcode-utils");
var _lowcodeEditorCore = require("@redhare/lowcode-editor-core");
var _react = _interopRequireDefault(require("react"));
function ContextMenu(_ref) {
  var children = _ref.children,
    menus = _ref.menus,
    pluginContext = _ref.pluginContext;
  if (!_lowcodeEditorCore.engineConfig.get('enableContextMenu')) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children);
  }
  var handleContextMenu = function handleContextMenu(event) {
    event.preventDefault();
    event.stopPropagation();
    var destroyFn;
    var destroy = function destroy() {
      var _destroyFn;
      (_destroyFn = destroyFn) === null || _destroyFn === void 0 ? void 0 : _destroyFn();
    };
    var children = (0, _lowcodeUtils.parseContextMenuAsReactNode)((0, _lowcodeUtils.parseContextMenuProperties)(menus, {
      destroy: destroy,
      pluginContext: pluginContext
    }), {
      pluginContext: pluginContext
    });
    if (!(children !== null && children !== void 0 && children.length)) {
      return;
    }
    destroyFn = (0, _lowcodeUtils.createContextMenu)(children, {
      event: event
    });
  };

  // 克隆 children 并添加 onContextMenu 事件处理器
  var childrenWithContextMenu = _react["default"].Children.map(children, function (child) {
    return /*#__PURE__*/_react["default"].cloneElement(child, {
      onContextMenu: handleContextMenu
    });
  });
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, childrenWithContextMenu);
}
ContextMenu.create = function (pluginContext, menus, event) {
  var children = (0, _lowcodeUtils.parseContextMenuAsReactNode)((0, _lowcodeUtils.parseContextMenuProperties)(menus, {
    pluginContext: pluginContext
  }), {
    pluginContext: pluginContext
  });
  if (!(children !== null && children !== void 0 && children.length)) {
    return;
  }
  return (0, _lowcodeUtils.createContextMenu)(children, {
    event: event
  });
};